using CallCenterApi.DB;
using System;
using System.Collections.Generic;
using System.Data;
using System.Data.SqlClient;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace CallCenterApi.DAL
{
    /// <summary>
    /// 数据访问类:T_Bus_Supervision
    /// </summary>
    public partial class T_Bus_Supervision
    {
        public T_Bus_Supervision()
        { }
        #region  BasicMethod



        /// <summary>
        /// 增加一条数据
        /// </summary>
        public int Add(CallCenterApi.Model.T_Bus_Supervision model)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("insert into T_Bus_Supervision(");
            strSql.Append("F_Code,F_UserCode,F_SERIALNUM,F_WorkOrderId,F_Title,F_Level,F_LimitTime,F_Opinion,F_CreateTime,F_DealUser,F_Result,F_DealTime,F_Type,F_IsDelete,F_Situation,F_File,F_Content,F_State)");
            strSql.Append(" values (");
            strSql.Append("@F_Code,@F_UserCode,@F_SERIALNUM,@F_WorkOrderId,@F_Title,@F_Level,@F_LimitTime,@F_Opinion,@F_CreateTime,@F_DealUser,@F_Result,@F_DealTime,@F_Type,@F_IsDelete,@F_Situation,@F_File,@F_Content,@F_State)");
            strSql.Append(";select @@IDENTITY");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_Code", SqlDbType.NVarChar,200),
                    new SqlParameter("@F_UserCode", SqlDbType.NVarChar,200),
                    new SqlParameter("@F_SERIALNUM", SqlDbType.VarChar,200),
                    new SqlParameter("@F_WorkOrderId", SqlDbType.NVarChar,100),
                    new SqlParameter("@F_Title", SqlDbType.NVarChar,500),
                    new SqlParameter("@F_Level",SqlDbType.NVarChar,100),
                    new SqlParameter("@F_LimitTime", SqlDbType.DateTime),
                    new SqlParameter("@F_Opinion", SqlDbType.NVarChar,-1),
                    new SqlParameter("@F_CreateTime", SqlDbType.DateTime),
                    new SqlParameter("@F_DealUser", SqlDbType.NVarChar,50),
                    new SqlParameter("@F_Result", SqlDbType.NVarChar,-1),
                    new SqlParameter("@F_DealTime", SqlDbType.DateTime),
                    new SqlParameter("@F_Type", SqlDbType.Int,4),
                    new SqlParameter("@F_IsDelete", SqlDbType.Int,4),
                    new SqlParameter("@F_Situation", SqlDbType.NVarChar,-1),
                    new SqlParameter("@F_File", SqlDbType.NVarChar,50),
                    new SqlParameter("@F_Content", SqlDbType.NVarChar,-1),
                    new SqlParameter("@F_State", SqlDbType.Int,4),
            };
            parameters[0].Value = model.F_Code;
            parameters[1].Value = model.F_UserCode;
            parameters[2].Value = model.F_SERIALNUM;
            parameters[3].Value = model.F_WorkOrderId;
            parameters[4].Value = model.F_Title;
            parameters[5].Value = model.F_Level;
            parameters[6].Value = model.F_LimitTime;
            parameters[7].Value = model.F_Opinion;
            parameters[8].Value = model.F_CreateTime;
            parameters[9].Value = model.F_DealUser;
            parameters[10].Value = model.F_Result;
            parameters[11].Value = model.F_DealTime;
            parameters[12].Value = model.F_Type;
            parameters[13].Value = model.F_IsDelete;
            parameters[14].Value = model.F_Situation;
            parameters[15].Value = model.F_File;
            parameters[16].Value = model.F_Content;
            parameters[17].Value = model.F_State ;
            object obj = DbHelperSQL.GetSingle(strSql.ToString(), parameters);
            if (obj == null)
            {
                return 0;
            }
            else
            {
                return Convert.ToInt32(obj);
            }
        }
        /// <summary>
        /// 更新一条数据
        /// </summary>
        public bool Update(CallCenterApi.Model.T_Bus_Supervision model)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("update T_Bus_Supervision set ");
            strSql.Append("F_Code=@F_Code,");
            strSql.Append("F_UserCode=@F_UserCode,");
            strSql.Append("F_SERIALNUM=@F_SERIALNUM,");
            strSql.Append("F_WorkOrderId=@F_WorkOrderId,");
            strSql.Append("F_Title=@F_Title,");
            strSql.Append("F_Level=@F_Level,");
            strSql.Append("F_LimitTime=@F_LimitTime,");
            strSql.Append("F_Opinion=@F_Opinion,");
            strSql.Append("F_CreateTime=@F_CreateTime,");
            strSql.Append("F_DealUser=@F_DealUser,");
            strSql.Append("F_Result=@F_Result,");
            strSql.Append("F_DealTime=@F_DealTime,");
            strSql.Append("F_Type=@F_Type,");
            strSql.Append("F_IsDelete=@F_IsDelete,");
            strSql.Append("F_Situation=@F_Situation,");
            strSql.Append("F_File=@F_File,");
            strSql.Append("F_Content=@F_Content,");
            strSql.Append("F_State=@F_State");
            strSql.Append(" where F_ID=@F_ID");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_Code", SqlDbType.NVarChar,200),
                    new SqlParameter("@F_UserCode", SqlDbType.NVarChar,200),
                    new SqlParameter("@F_SERIALNUM", SqlDbType.VarChar,200),
                    new SqlParameter("@F_WorkOrderId", SqlDbType.NVarChar,100),
                    new SqlParameter("@F_Title", SqlDbType.NVarChar,500),
                    new SqlParameter("@F_Level",SqlDbType.NVarChar,100),
                    new SqlParameter("@F_LimitTime", SqlDbType.DateTime),
                    new SqlParameter("@F_Opinion", SqlDbType.NVarChar,-1),
                    new SqlParameter("@F_CreateTime", SqlDbType.DateTime),
                    new SqlParameter("@F_DealUser", SqlDbType.NVarChar,50),
                    new SqlParameter("@F_Result", SqlDbType.NVarChar,-1),
                    new SqlParameter("@F_DealTime", SqlDbType.DateTime),
                    new SqlParameter("@F_Type", SqlDbType.Int,4),
                    new SqlParameter("@F_IsDelete", SqlDbType.Int,4),
                    new SqlParameter("@F_Situation", SqlDbType.NVarChar,-1),
                    new SqlParameter("@F_File", SqlDbType.NVarChar,50),
                    new SqlParameter("@F_Content", SqlDbType.NVarChar,-1),
                     new SqlParameter("@F_State", SqlDbType.Int,4),
                    new SqlParameter("@F_ID", SqlDbType.Int,4)};
            parameters[0].Value = model.F_Code;
            parameters[1].Value = model.F_UserCode;
            parameters[2].Value = model.F_SERIALNUM;
            parameters[3].Value = model.F_WorkOrderId;
            parameters[4].Value = model.F_Title;
            parameters[5].Value = model.F_Level;
            parameters[6].Value = model.F_LimitTime;
            parameters[7].Value = model.F_Opinion;
            parameters[8].Value = model.F_CreateTime;
            parameters[9].Value = model.F_DealUser;
            parameters[10].Value = model.F_Result;
            parameters[11].Value = model.F_DealTime;
            parameters[12].Value = model.F_Type;
            parameters[13].Value = model.F_IsDelete;
            parameters[14].Value = model.F_Situation;
            parameters[15].Value = model.F_File;
            parameters[16].Value = model.F_Content;
            parameters[17].Value = model.F_State;
            parameters[18].Value = model.F_ID;

            int rows = DbHelperSQL.ExecuteSql(strSql.ToString(), parameters);
            if (rows > 0)
            {
                return true;
            }
            else
            {
                return false;
            }
        }

        /// <summary>
        /// 删除一条数据
        /// </summary>
        public bool Delete(int F_ID)
        {

            StringBuilder strSql = new StringBuilder();
            strSql.Append("delete from T_Bus_Supervision ");
            strSql.Append(" where F_ID=@F_ID");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_ID", SqlDbType.Int,4)
            };
            parameters[0].Value = F_ID;

            int rows = DbHelperSQL.ExecuteSql(strSql.ToString(), parameters);
            if (rows > 0)
            {
                return true;
            }
            else
            {
                return false;
            }
        }
        /// <summary>
        /// 批量删除数据
        /// </summary>
        public bool DeleteList(string F_IDlist)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("delete from T_Bus_Supervision ");
            strSql.Append(" where F_ID in (" + F_IDlist + ")  ");
            int rows = DbHelperSQL.ExecuteSql(strSql.ToString());
            if (rows > 0)
            {
                return true;
            }
            else
            {
                return false;
            }
        }


        /// <summary>
        /// 得到一个对象实体
        /// </summary>
        public CallCenterApi.Model.T_Bus_Supervision GetModel(int F_ID)
        {

            StringBuilder strSql = new StringBuilder();
            strSql.Append("select  top 1 F_ID,F_Code,F_UserCode,F_SERIALNUM,F_WorkOrderId,F_Title,F_Level,F_LimitTime,F_Opinion,F_CreateTime,F_DealUser,F_Result,F_DealTime,F_Type,F_IsDelete,F_Situation,F_File,F_Content,F_State from T_Bus_Supervision ");
            strSql.Append(" where F_ID=@F_ID");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_ID", SqlDbType.Int,4)
            };
            parameters[0].Value = F_ID;

            CallCenterApi.Model.T_Bus_Supervision model = new CallCenterApi.Model.T_Bus_Supervision();
            DataSet ds = DbHelperSQL.Query(strSql.ToString(), parameters);
            if (ds.Tables[0].Rows.Count > 0)
            {
                return DataRowToModel(ds.Tables[0].Rows[0]);
            }
            else
            {
                return null;
            }
        }


        /// <summary>
        /// 得到一个对象实体
        /// </summary>
        public CallCenterApi.Model.T_Bus_Supervision DataRowToModel(DataRow row)
        {
            CallCenterApi.Model.T_Bus_Supervision model = new CallCenterApi.Model.T_Bus_Supervision();
            if (row != null)
            {
                if (row["F_ID"] != null && row["F_ID"].ToString() != "")
                {
                    model.F_ID = int.Parse(row["F_ID"].ToString());
                }
                if (row["F_Code"] != null)
                {
                    model.F_Code = row["F_Code"].ToString();
                }
                if (row["F_UserCode"] != null)
                {
                    model.F_UserCode = row["F_UserCode"].ToString();
                }
                if (row["F_SERIALNUM"] != null)
                {
                    model.F_SERIALNUM = row["F_SERIALNUM"].ToString();
                }
                if (row["F_WorkOrderId"] != null)
                {
                    model.F_WorkOrderId = row["F_WorkOrderId"].ToString();
                }
                if (row["F_Title"] != null)
                {
                    model.F_Title = row["F_Title"].ToString();
                }
                if (row["F_Level"] != null && row["F_Level"].ToString() != "")
                {
                    model.F_Level = row["F_Level"].ToString();
                }
                if (row["F_LimitTime"] != null && row["F_LimitTime"].ToString() != "")
                {
                    model.F_LimitTime = DateTime.Parse(row["F_LimitTime"].ToString());
                }
                if (row["F_Opinion"] != null)
                {
                    model.F_Opinion = row["F_Opinion"].ToString();
                }
                if (row["F_CreateTime"] != null && row["F_CreateTime"].ToString() != "")
                {
                    model.F_CreateTime = DateTime.Parse(row["F_CreateTime"].ToString());
                }
                if (row["F_DealUser"] != null)
                {
                    model.F_DealUser = row["F_DealUser"].ToString();
                }
                if (row["F_Result"] != null)
                {
                    model.F_Result = row["F_Result"].ToString();
                }
                if (row["F_DealTime"] != null && row["F_DealTime"].ToString() != "")
                {
                    model.F_DealTime = DateTime.Parse(row["F_DealTime"].ToString());
                }
                if (row["F_Type"] != null && row["F_Type"].ToString() != "")
                {
                    model.F_Type = int.Parse(row["F_Type"].ToString());
                }
                if (row["F_IsDelete"] != null && row["F_IsDelete"].ToString() != "")
                {
                    model.F_IsDelete = int.Parse(row["F_IsDelete"].ToString());
                }
                if (row["F_Situation"] != null)
                {
                    model.F_Situation = row["F_Situation"].ToString();
                }
                if (row["F_File"] != null)
                {
                    model.F_File = row["F_File"].ToString();
                }
                if (row["F_Content"] != null)
                {
                    model.F_Content = row["F_Content"].ToString();
                }
                if (row["F_State"] != null && row["F_State"].ToString() != "")
                {
                    model.F_State = int.Parse(row["F_State"].ToString());
                }
                
            }
            return model;
        }

        /// <summary>
        /// 获得数据列表
        /// </summary>
        public DataSet GetList(string strWhere)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select F_ID,F_Code,F_UserCode,F_SERIALNUM,F_WorkOrderId,F_Title,F_Level,F_LimitTime,F_Opinion,F_CreateTime,F_DealUser,F_Result,F_DealTime,F_Type,F_IsDelete,F_Situation,F_File,F_Content,F_State ");
            strSql.Append(" FROM T_Bus_Supervision ");
            if (strWhere.Trim() != "")
            {
                strSql.Append(" where " + strWhere);
            }
            return DbHelperSQL.Query(strSql.ToString());
        }

        /// <summary>
        /// 获得前几行数据
        /// </summary>
        public DataSet GetList(int Top, string strWhere, string filedOrder)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select ");
            if (Top > 0)
            {
                strSql.Append(" top " + Top.ToString());
            }
            strSql.Append(" F_ID,F_Code,F_UserCode,F_SERIALNUM,F_WorkOrderId,F_Title,F_Level,F_LimitTime,F_Opinion,F_CreateTime,F_DealUser,F_Result,F_DealTime,F_Type,F_IsDelete,F_Situation,F_File,F_Content,F_State ");
            strSql.Append(" FROM T_Bus_Supervision ");
            if (strWhere.Trim() != "")
            {
                strSql.Append(" where " + strWhere);
            }
            strSql.Append(" order by " + filedOrder);
            return DbHelperSQL.Query(strSql.ToString());
        }

        /// <summary>
        /// 获取记录总数
        /// </summary>
        public int GetRecordCount(string strWhere)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select count(1) FROM T_Bus_Supervision ");
            if (strWhere.Trim() != "")
            {
                strSql.Append(" where " + strWhere);
            }
            object obj = DbHelperSQL.GetSingle(strSql.ToString());
            if (obj == null)
            {
                return 0;
            }
            else
            {
                return Convert.ToInt32(obj);
            }
        }
        /// <summary>
        /// 分页获取数据列表
        /// </summary>
        public DataSet GetListByPage(string strWhere, string orderby, int startIndex, int endIndex)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("SELECT * FROM ( ");
            strSql.Append(" SELECT ROW_NUMBER() OVER (");
            if (!string.IsNullOrEmpty(orderby.Trim()))
            {
                strSql.Append("order by T." + orderby);
            }
            else
            {
                strSql.Append("order by T.F_ID desc");
            }
            strSql.Append(")AS Row, T.*  from T_Bus_Supervision T ");
            if (!string.IsNullOrEmpty(strWhere.Trim()))
            {
                strSql.Append(" WHERE " + strWhere);
            }
            strSql.Append(" ) TT");
            strSql.AppendFormat(" WHERE TT.Row between {0} and {1}", startIndex, endIndex);
            return DbHelperSQL.Query(strSql.ToString());
        }

        /*
		/// <summary>
		/// 分页获取数据列表
		/// </summary>
		public DataSet GetList(int PageSize,int PageIndex,string strWhere)
		{
			SqlParameter[] parameters = {
					new SqlParameter("@tblName", SqlDbType.VarChar, 255),
					new SqlParameter("@fldName", SqlDbType.VarChar, 255),
					new SqlParameter("@PageSize", SqlDbType.Int),
					new SqlParameter("@PageIndex", SqlDbType.Int),
					new SqlParameter("@IsReCount", SqlDbType.Bit),
					new SqlParameter("@OrderType", SqlDbType.Bit),
					new SqlParameter("@strWhere", SqlDbType.VarChar,1000),
					};
			parameters[0].Value = "T_Bus_Supervision";
			parameters[1].Value = "F_ID";
			parameters[2].Value = PageSize;
			parameters[3].Value = PageIndex;
			parameters[4].Value = 0;
			parameters[5].Value = 0;
			parameters[6].Value = strWhere;	
			return CallCenterApi.RunProcedure("UP_GetRecordByPage",parameters,"ds");
		}*/

        #endregion  BasicMethod
        #region  ExtensionMethod

        #endregion  ExtensionMethod
    }
}
